class TEXT_URL_READ
	--
	-- Basic input facilities to read a named url.
	--

inherit
	TEXT_FILE_READ
		redefine basic_io_text_file_read_open, basic_io_fclose,
				basic_io_fread,	basic_io_eof
		end

creation
	make, connect_to

feature -- redefined features

	basic_io_text_file_read_open(path_pointer: POINTER): POINTER is
	local
		operation: STRING
	do
		operation := "r"
		Result := url_fopen (path_pointer, operation.to_external)
	end

	basic_io_getc(stream_pointer: POINTER): INTEGER is
	local
		buf: NATIVE_ARRAY[INTEGER_8]
	do
		buf := buf.calloc(1)
		if basic_io_fread (buf, 1, stream_pointer) = 0 then
			Result := -1
		else
			Result := buf.at (0)
		end
	end

	basic_io_fread(buf: NATIVE_ARRAY[CHARACTER]; size: INTEGER; stream_pointer: POINTER): INTEGER is
	  -- return size read or 0 if end of input (-1 on error => exception ?)
	do
		Result := url_fread (buf, 1, size, stream_pointer)
	end

feature -- external features

	basic_io_fclose(stream_pointer: POINTER) is
	external "C" alias "url_fclose"
	end

	basic_io_eof: INTEGER is
	external "C" alias "url_feof"
	end

	url_fopen(path_pointer: POINTER; operation: POINTER): POINTER is
	external "C"
	end

	url_fread(buf: NATIVE_ARRAY[CHARACTER]; tam: INTEGER; size: INTEGER; stream_pointer: POINTER): INTEGER is
	external "C"
	end

end -- class TEXT_URL_READ
